<ng-container *ngFor="let item of stepList">
  <!-- first item -->
  <ng-container *ngIf="item === 1; else notFirst">
    <!-- step -->
    <ng-container *ngTemplateOutlet="ball; context: { index: item }"></ng-container>
  </ng-container>

  <!-- not first-->
  <ng-template #notFirst>
    <!-- step line -->
    <div class="app-step-line"></div>

    <!-- step -->
    <ng-container *ngTemplateOutlet="ball; context: { index: item }"></ng-container>
  </ng-template>
</ng-container>

<!-- step template -->
<ng-template #ball let-index="index">
  <!-- step -->
  <div
    (click)="emitStepChange(index)"
    [class.current]="index === step"
    [class.next]="index > step"
    [class.previous]="index < step"
    class="app-step"
  >
    <!-- if step is bigger than index -->
    <ng-container *ngIf="index < step; else value">
      <!-- check icon -->
      <app-icon-check></app-icon-check>
    </ng-container>

    <!-- show index -->
    <ng-template #value>
      {{ index }}
    </ng-template>
  </div>
</ng-template>
